<link rel="import" href="/bower_components/polymer/polymer-element.html">
<link rel="import" href="../l1page-theme/l1page-theme.html">

<link rel="import" href="/bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="/bower_components/polymer/lib/elements/dom-repeat.html">

<link rel="import" href="/bower_components/paper-toast/paper-toast.html">
<link rel="import" href="/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/bower_components/paper-dialog-scrollable/paper-dialog-scrollable.html">
<link rel="import" href="/bower_components/paper-button/paper-button.html">
<link rel="import" href="/bower_components/paper-input/paper-input.html">
<link rel="import" href="/bower_components/paper-input/paper-textarea.html">
<link rel="import" href="when-life-gives-you-lemons-make-toast.html">

<!--
`toast-manager` can globally receive messages to show to the user.
These can be displayed as a [paper-toast](https://elements.polymer-project.org/elements/paper-toast) on the bottom of the screen. A [paper-toast](https://elements.polymer-project.org/elements/paper-toast) with clickable options. Or a [paper-dialog](https://elements.polymer-project.org/elements/paper-dialog) forcing the user to choose an option.

Only one `toast-manager` should exist per project.
To be able to send messages to this element, regardless of location, implement the 'throwsToast' behavior in your element.

Example:

    <toast-manager></toast-manager>

Element example:

    <link rel="import" href="/elements/toast-manager/throws-toast.html">

    ...

    behaviors: [throwsToast],

    ...

    this.throwToast({
      'type': 'error',
      'message': 'this is a big error, you will need to choose something',
      'options': ['save the world', 'make dinosaurs'],
      'blocking': true,
      'callback': function(response) {
        console.log("you have chosen to", response.action);
      }
    });

@demo
-->
<dom-module id="toast-manager">
  <template>
    <link rel="stylesheet" href="toast-manager.css?__inline=true">
    <style include="l1page-theme"></style>

    <paper-dialog modal id=modal on-iron-overlay-closed=_modalClosed type$=[[_toast.type]]>
      <h2>[[_toast.header]]</h2>
      <paper-dialog-scrollable id=messagecontainer></paper-dialog-scrollable>
      <dom-if if="[[_showTextArea(_toast.input)]]" restamp=true>
        <template>
          <paper-textarea label=[[_toast.input.label]] value={{_toast.input.value}} auto-validate required error-message="[[_toast.input.label]] cannot be empty" invalid={{input_invalid}}></paper-textarea>
        </template>
      </dom-if>
      <dom-if if="[[_showInput(_toast.input)]]" restamp=true>
        <template>
          <paper-input label=[[_toast.input.label]] value={{_toast.input.value}} type=[[_toast.input.type]]></paper-input>
        </template>
      </dom-if>
      <div class=buttons>
        <dom-repeat items={{_toast.options}} as=option>
          <template>
            <paper-button on-click=_dialogButtonClick disabled$="[[_inputDisabled(_toast.input, input_invalid)]]">{{option}}</paper-button>
          </template>
        </dom-repeat>
      </div>
    </paper-dialog>

    <paper-toast id=toast text=[[_toast.message]] type$=[[_toast.type]] duration=[[duration]]>
      <dom-repeat items={{_toast.options}} as=option>
        <template>
          <paper-button on-click=_toastButtonClick>[[option]]</paper-button>
        </template>
      </dom-repeat>
    </paper-toast>

    <slot></slot>
  </template>
</dom-module>

<script src="toast-manager.js?__inline=true"></script>
